#!/usr/bin/python3
import os
import sys
def main():
    """
        read in latex file in red blue line 
        filtout strikeout words, delete \add, delete \aq{bla...}.
        Revised at 2011.6.15 by LXH:
           filtout '\add{' and '}' in \add{ blabla...}
    """
    if len( sys.argv ) > 1:
       filename = sys.argv[1]
    else:
       filename = raw_input("Please input original tex file name: ")
    objname = os.path.basename(filename)
## 1. read in latex file
    f1 = open(objname, encoding="utf-8", errors='ignore')
    linestring = f1.read()
    f1.close()

    f2 = open("filted_" + objname,"w")
    #temp = open("temp.tex","w")

## 2. filtout \del{} or \de{}


    while ((linestring.find("\\del{") >= 0) | (linestring.find("\\de{") >= 0)):
        m = linestring.find("\\del{")
        n = linestring.find("\\de{")
        
        if ((m >=0) & ((m < n) | (n < 0))):
           ii = linestring.find("\\del{")
        if ((n >=0) & ((n < m) | (m < 0))):
           ii = linestring.find("\\de{")

        newlinestring = linestring[:ii]
        leftstring = linestring[ii:]
        
        pos = leftstring.find("}")
        delstr = leftstring[:pos+1]
        leftstring = leftstring[pos+1:]
        while (delstr.count("{") > delstr.count("}")):
           pos = leftstring.find("}")
           delstr = delstr + leftstring[:pos+1]
           leftstring = leftstring[pos+1:]

        linestring = newlinestring + leftstring
        #print "haha",leftstring
 
    # get rid of "\aq{}"

    while (linestring.find("\\aq{") >= 0):
        ii = linestring.find("\\aq{")

        newlinestring = linestring[:ii]
        leftstring = linestring[ii:]
        
        pos = leftstring.find("}")
        delstr = leftstring[:pos+1]
        leftstring = leftstring[pos+1:]
        while (delstr.count("{") > delstr.count("}")):
           pos = leftstring.find("}")
           delstr = delstr + leftstring[:pos+1]
           leftstring = leftstring[pos+1:]

        linestring = newlinestring + leftstring
    
## 4. filtout \add{ } or \ad{}

#    linestring = linestring.replace("\\add","")
#    linestring = linestring.replace("\\ad","")

    while ((linestring.find("\\add{") >= 0) | (linestring.find("\\ad{") >= 0)):
        m = linestring.find("\\add{")
        n = linestring.find("\\ad{")
        
        if ((m >=0) & ((m < n) | (n < 0))):
           ii = linestring.find("\\add{")
           adlen = len("\\add{")
        if ((n >=0) & ((n < m) | (m < 0))):
           ii = linestring.find("\\ad{")
           adlen = len("\\ad{")

        newlinestring = linestring[:ii]
        leftstring = linestring[ii:]
        
        pos = leftstring.find("}")
        addstr = leftstring[:pos+1]
        leftstring = leftstring[pos+1:]
        while (addstr.count("{") > addstr.count("}")):
           pos = leftstring.find("}")
           addstr = addstr + leftstring[:pos+1]
           leftstring = leftstring[pos+1:]

        leftstring = addstr[adlen:(len(addstr)-1)] + leftstring

        linestring = newlinestring + leftstring
        #print "haha",addstr, addstr[adlen:(len(addstr)-1)]

## 5. write out to another latex file
        
    f2.write(linestring)
    f2.close()
    print("The filted tex was written to: filted_" + objname)

if __name__=="__main__":
    main()

